set SSS_PROG "bravais"

#mod rbr
set SSS_CTRLB1 0

set recipsize 12
set realsize 6
set diff_spots_num 169
set atomA 1
set atomB 1
set real_lattice 1
set recip_lattice 0
set xray 1
set planes 0
set brav_palette 0

###################################################################
#mod spt
#getting the screen size and using if for fixing the screen size.

#global variable font, wdth and hght and initializing them.

set font "-*-helvetica-bold-r-normal-*-*-90-*-*-*-*-*-"
set wdth 0
set hght 0
proc startup {} {
global wd ht wdth hght font SCALE disp_option BINS PIXEL tcl_platform
set wd [winfo screenwidth .]
set ht [winfo screenheight .]
if {$wd <= 640} {
	set wdth 240
	set hght 240
	set disp_option "small"
	wm minsize . 600 480
	wm maxsize . 750 600
    	if { $tcl_platform(platform) == "unix" } {
		set font "-*-helvetica-medium-r-normal-*-*-80-*-*-*-*-*-*"
	} else {
		set font "-*-helvetica-bold-r-normal-*-*-90-*-*-*-*-*-*"
	}
	set BINS 12
	set PIXEL 120
	} elseif {$wd <= 800} {
		set wdth 300
		set hght 300
		set disp_option "medium"
	        if { $tcl_platform(platform) == "unix" } {
		    set font "-*-helvetica-medium-r-normal-*-*-100-*-*-*-*-*-*"
		} else {
		    set font "-*-helvetica-bold-r-normal-*-*-100-*-*-*-*-*-*"
		}
		wm minsize . 740 490
		wm maxsize . 850 550
		set BINS 15
		set PIXEL 150
		 } else {
			set wdth 400
			set hght 400
			set disp_option "large"
			set font "-*-helvetica-bold-r-normal-*-*-120-*-*-*-*-*-*"
			wm minsize . 1000 570
			wm maxsize . 4000 3000
			set BINS 20
			set PIXEL 200
			}
}

proc set_para {} {
global wd ht wdth hght font SCALE disp_option BINS PIXEL tcl_platform
set wd [winfo screenwidth .]
set ht [winfo screenheight .]
if {$disp_option == "small"} {
	set wdth 240
	set hght 240
	wm minsize . 600 480
	wm maxsize . 750 600
    	if { $tcl_platform(platform) == "unix" } {
		set font "-*-helvetica-medium-r-normal-*-*-80-*-*-*-*-*-*"
	} else {
		set font "-*-helvetica-bold-r-normal-*-*-90-*-*-*-*-*-*"
	}
	set BINS 12
	set PIXEL 120

	} elseif {$disp_option == "medium"} {
		set wdth 300
		set hght 300
	        if { $tcl_platform(platform) == "unix" } {
		    set font "-*-helvetica-medium-r-normal-*-*-100-*-*-*-*-*-*"
		} else {
		    set font "-*-helvetica-bold-r-normal-*-*-100-*-*-*-*-*-*"
		}
		wm minsize . 740 490
		wm maxsize . 850 550
		set BINS 15
		set PIXEL 150
	 } else {
			set wdth 400
			set hght 400
			set font "-*-helvetica-bold-r-normal-*-*-120-*-*-*-*-*-*"
			wm minsize . 1000 570
			wm maxsize . 4000 3000
			set BINS 20
			set PIXEL 200

			}
	# Configuring the font for all the widgets.
	config_all

	#if {[winfo reqwidth .] > $wd } {
		#Setting geometry as much as needed.
	#	wm geometry . [winfo reqwidth .]x[winfo reqheight .]+[winfo x .]+[winfo y .]
	#}

}


#mod spt
startup
################# the presetsave procedure ############################
proc presetsave {file} {

	 #global variables & checkbuttons
	 foreach s {real_lattice recip_lattice planes xray lattice atomA atomB h k} {
	global $s
	puts $file "set $s [set $s]"
	 }

	 #selections
	 foreach s {} {
	set val [LASSPselection_set $s]
	puts $file "LASSPselection_set $s $val"
	 }

	 #sliders
	 foreach s {.control.latt_consts.phi .control.latt_consts.a \
		 .control.latt_consts.b .control.atomAf.a1 .control.atomAf.b1 \
		 .control.atomAf.z1 .control.atomAf.r1 .control.atomBf.a2 \
		 .control.atomBf.b2 .control.atomBf.z2 .control.atomBf.r2} {
	set val [LASSPscale2_configure $s -scrollinc]
	puts $file "LASSPscale2_configure $s -scrollinc $val"
	set val [LASSPscale2_configure $s -scrollmin]
	puts $file "LASSPscale2_configure $s -scrollmin $val"
	set val [LASSPscale2_configure $s -scrollmax]
	puts $file "LASSPscale2_configure $s -scrollmax $val"
	set val [LASSPscale2_configure $s -scrolltype]
	puts $file "LASSPscale2_configure $s -scrolltype $val"
# rbr no fonts in presets
#	set val [LASSPscale2_configure $s -font]
#	puts $file "LASSPscale2_configure $s -font $val"

	set var [LASSPscale2_configure $s -var]
	global $var
	puts $file "LASSPscale2_set -nocommand $s [set $var]"
	 }

	 #redraw after preset is recalled
	 puts $file "pos_update"
	 puts $file "color_update"
	 puts $file "real_lattice_toggle"
	 puts $file "recip_lattice_toggle"
	 puts $file "atom_toggle atomA .realf.can atomA"
	 puts $file "atom_toggle atomB .realf.can atomB"
	 puts $file ".recipf.can delete pathline"
	 puts $file ".realf.can delete pathline"
	 puts $file "lattice_planes"

	 puts $file ".recipf.vecf.h delete 0 end"
	 puts $file ".recipf.vecf.k delete  0 end"
	 puts $file ".recipf.vecf.h insert 0 $h"
	 puts $file ".recipf.vecf.k insert 0 $k"
}

#turn an set of objects with a given tag on or off, depending on a variable var
proc atom_toggle {var canvas tag} {
	 global $var
	 set can [format {%s} $canvas]
	 set tg [format {%s} $tag]
	 set testvar [set $var]
	 if {"$testvar" == 0} {
	$can itemconfigure $tg -fill {} -outline {}
	pos_update; color_update
	 } else {
	$can itemconfigure $tg -fill red -outline black
	pos_update; color_update
	 }
}


########turn the lattice of crosses in the real space display on and off
proc real_lattice_toggle {} {
	 global real_lattice
	 global realsize
	 set o_id [expr ($realsize+1)*($realsize+1)]
	 if {$real_lattice} {
	.realf.can itemconfigure real_lattice -fill red
	.realf.can itemconfigure origin -fill black
	pos_update
	 } else {
	.realf.can itemconfigure real_lattice -fill {}
	.realf.can itemconfigure origin -fill {}
	 }
}

#######turn the lattice of lines in the reciprocal space on and off
proc recip_lattice_toggle {} {
	 global recip_lattice
	 if {$recip_lattice} {
	.recipf.can  itemconfigure recip_lattice -fill red
	pos_update
	 } else {
	.recipf.can itemconfigure recip_lattice -fill {}
		 }
}


######find the nearest object with the given tag, and id greater than start
proc finder {canvas x y tag start} {
	 global selected
	 global h
	 global k
	 global recipsize

	 set selected [$canvas find closest $x $y 1 $start]
	 set halo 0
	 while {([string first $tag [$canvas gettags $selected]] < 0 ) && ($halo<200)} {
	global selected
	set halo [expr $halo + 5]
	set selected [$canvas find closest $x $y $halo $start]
	 }
	 set h [expr ($selected-1)%($recipsize +1) - $recipsize/2]
	 set k [expr ($selected-1)/($recipsize+1) - $recipsize/2]

	 .recipf.vecf.h delete 0 end
	 .recipf.vecf.k delete  0 end
	 .recipf.vecf.h insert 0 $h
	 .recipf.vecf.k insert 0 $k

}

proc bravais_sorry { } {
	 if { [winfo exists .noconfig] } {
	raise .noconfig
	 } else {
	toplevel .noconfig
	button .noconfig.ok -text "Close" -command { destroy .noconfig }
	label .noconfig.label -text "Sorry, bravais has no items to configure" -justify center
	pack .noconfig.label -side top -fill x -padx 10 -pady 10
	pack .noconfig.ok -side bottom -pady 5
	wm title .noconfig "Sorry"
	raise .noconfig
	 }
}

################# setup canvases and their frames and mouse bindings
##############real space
frame .realf
canvas .realf.can -height $hght -width $wdth -relief raised

#bind left mouse to draw a line, display length and angle
bind .realf.can <ButtonPress-1> {
	 .realf.can delete pathline
	 .realf.can create line %x %y %x %y -tag pathline
}
bind .realf.can <B1-Motion> {
	 set cor [lreplace [.realf.can coords pathline] 2 3 %x %y]
	 eval ".realf.can coords pathline $cor"
}
bind .realf.can <ButtonRelease-1> {
	 set temp [.realf.can coords pathline]
	 show_line .realf [lindex $temp 0] [lindex $temp 1] [lindex $temp 2] [lindex $temp 3]
}

#boxes to show the length and angle of a line drawn with the mouse
frame .realf.posf
label .realf.posf.length_l -font $font -text "length (A)"
label .realf.posf.length_e -width 7 -relief sunken
label .realf.posf.angle_l -font $font -text "alpha"
label .realf.posf.angle_e -width 7  -relief sunken

#toggle button for the lattice
checkbutton .realf.posf.lattice -font $font -text "lattice" -command real_lattice_toggle -variable real_lattice

#######################reciprocal space
frame .recipf
canvas .recipf.can -height $hght -width $wdth -relief raised -background black

#bind both right mouse button and double-left to select a reciprocal
#lattice vector, and draw Bragg planes
#mod rbr - diff_spots_num to diff_spots_num+1 and for double-b1 below
bind .recipf.can <Button-3> {
	 finder .recipf.can "%x" "%y" diff_spots [expr $diff_spots_num+1]
	 lattice_planes
}
#mod rbr button-3 to control-button-1
bind .recipf.can <Control-Button-1> [bind .recipf.can <Button-3>]

bind .recipf.can <Double-Button-1> {
	 finder .recipf.can "%x" "%y" diff_spots [expr $diff_spots_num+1]
	 lattice_planes
}

#bind left mouse button to draw line, display length and angle
bind .recipf.can <ButtonPress-1> {
	 .recipf.can delete pathline
	 .recipf.can create line %x %y %x %y -tag pathline -fill white
}
#mod rbr
bind .recipf.can <Control-ButtonPress-1> {
	global SSS_CTRLB1
	set SSS_CTRLB1 1
}
#mod rbr 
bind .recipf.can <B1-Motion> {
	global SSS_CTRLB1
	if { $SSS_CTRLB1 == 0 } {
	 set cor [lreplace [.recipf.can coords pathline] 2 3 %x %y]
	 eval ".recipf.can coords pathline $cor"
	}
}
#mod rbr
bind .recipf.can <Control-B1-Motion> { }

bind .recipf.can <ButtonRelease-1> {
	#mod rbr
	global SSS_CTRLB1
	if { $SSS_CTRLB1 == 0 } {
	 set temp [.recipf.can coords pathline]
	 show_line .recipf [lindex $temp 0] [lindex $temp 1] [lindex $temp 2] [lindex $temp 3]
	} else {
	 set SSS_CTRLB1 0
	 finder .recipf.can "%x" "%y" diff_spots [expr $diff_spots_num+1]
	 lattice_planes
	}
}
#mod rbr
bind .recipf.can <Control-ButtonRelease-1> {
	global SSS_CTRLB1
	if { $SSS_CTRLB1 == 0 } {
	 set temp [.recipf.can coords pathline]
	 show_line .recipf [lindex $temp 0] [lindex $temp 1] [lindex $temp 2] [lindex $temp 3]
	} else {
	 set SSS_CTRLB1 0
	 finder .recipf.can "%x" "%y" diff_spots [expr $diff_spots_num+1]
	 lattice_planes
	}
}

#controls for choosing and displaying a reciprocal space lattice vector
frame .recipf.vecf
checkbutton .recipf.vecf.planes -font $font -text "show planes" -command lattice_planes -variable planes
.recipf.vecf.planes deselect
label .recipf.vecf.hlab -font $font -text "Miller indices: h"
LASSPentry .recipf.vecf.h {catch {set h [expr ~~[%W get]]; lattice_planes}} -width 3 -relief sunken
label .recipf.vecf.klab -font $font -text "k"
LASSPentry .recipf.vecf.k {catch {set k [expr ~~[%W get]]; lattice_planes}} -width 3 -relief sunken

#show the length, angle of a line drawn with the mouse
frame .recipf.posf
frame .recipf.posf.topf
frame .recipf.posf.bottomf

label .recipf.posf.topf.length_l -font $font -text "length (1/A)"
label .recipf.posf.topf.length_e -width 7 -relief sunken
label .recipf.posf.topf.angle_l -font $font -text "beta"
label .recipf.posf.topf.angle_e -width 7  -relief sunken

#toggle for the reciprocal lattice
checkbutton .recipf.posf.bottomf.lattice -font $font -text "lattice" -command recip_lattice_toggle -variable recip_lattice

#toggle for diffraction spots
checkbutton .recipf.posf.bottomf.diffraction -font $font -text "diffraction" -command {pos_update; color_update} -variable xray

#####setup controls for position, charge, radius of the atoms
frame .control  -bd 2
frame .control1  -bd 2
frame .control1.latt_consts -relief sunken -bd 2
frame .control.atomAf -relief sunken -bd 2
frame .control.atomBf -relief sunken -bd 2

#controls for physical variables
LASSPscale2 .control1.latt_consts.phi -text "phi: " -scrollmin 40 -scrollmax 140 -initial 90 -var phi -scrollinc 1 -test {{%v>0} && {%v<180}} -command {pos_update; color_update; lattice_planes; update idletasks}
LASSPscale2_configure .control1.latt_consts.phi -font $font
LASSPscale2 .control1.latt_consts.a -text "a1 (A): " -scrollmin 2 -scrollmax 7 -initial 5 -var a1 -scrollinc .1 -command {pos_update; color_update; lattice_planes; update idletasks}
LASSPscale2_configure .control1.latt_consts.a -font $font
LASSPscale2 .control1.latt_consts.b -text "a2 (A): " -scrollmin 2 -scrollmax 7 -initial 5 -var a2 -scrollinc .1 -command {pos_update;  color_update; lattice_planes; update idletasks}
LASSPscale2_configure .control1.latt_consts.b -font $font
checkbutton .control1.latt_consts.lattice -font $font -text "lattice" -variable lattice -command lattice_toggle

LASSPscale2  .control.atomAf.a1 -text "A1 (a1): " -scrollmin 0 -scrollmax 1 -initial 0 -scrollinc .01 -var atomA1 -command {color_update; move_in_cell atomA; update idletasks}
LASSPscale2_configure .control.atomAf.a1 -font $font
LASSPscale2 .control.atomAf.b1 -text "A2 (a2): " -scrollmin 0 -scrollmax 1 -initial 0 -scrollinc .01 -var atomA2 -command {move_in_cell atomA; color_update; update idletasks}
LASSPscale2_configure .control.atomAf.b1 -font $font
LASSPscale2  .control.atomAf.z1 -text "atom# ZA: " -scrollmin 0 -scrollmax 100 -initial 100 -scrollinc 1 -var atomAZ -command {color_update; update idletasks} -type integer -test {%v>=0 && %v<=100}
LASSPscale2_configure .control.atomAf.z1 -font $font
LASSPscale2 .control.atomAf.r1 -text "radiusA (A): " -scrollmin 0 -scrollmax 1 -initial 0.2 -scrollinc .01 -var atomAr -command {color_update; resize_atom; update idletasks} -test {%v>=0}
LASSPscale2_configure .control.atomAf.r1 -font $font

checkbutton .control.atomAf.toggle -font $font -text "atom A" -variable atomA -command { atom_toggle atomA .realf.can atomA}
.control.atomAf.toggle select

LASSPscale2 .control.atomBf.a2 -text "B1 (a1): " -scrollmin 0 -scrollmax 1 -initial .25 -scrollinc .01 -var atomB1 -command {move_in_cell atomB; color_update; update idletasks}
LASSPscale2_configure .control.atomBf.a2 -font $font
LASSPscale2 .control.atomBf.b2 -text "B2 (a2): " -scrollmin 0 -scrollmax 1 -initial .25 -scrollinc .01 -var atomB2 -command {move_in_cell atomB; color_update; update idletasks}
LASSPscale2_configure .control.atomBf.b2 -font $font
LASSPscale2  .control.atomBf.z2 -text "atom# ZB: " -scrollmin 0 -scrollmax 100 -initial  100 -scrollinc 1 -var atomBZ -command {color_update; update idletasks} -type integer -test {%v>=0}
LASSPscale2_configure .control.atomBf.z2 -font $font
LASSPscale2 .control.atomBf.r2 -text "radiusB (A): " -scrollmin 0 -scrollmax 1 -initial 0.2 -scrollinc .01 -var atomBr -command {color_update; resize_atom; update idletasks} -test {%v>=0 && %v<=100}
LASSPscale2_configure .control.atomBf.r2 -font $font

checkbutton .control.atomBf.toggle -font $font -text "atom B" -variable atomB -command {atom_toggle atomB .realf.can atomB}
.control.atomBf.toggle select

#mod spt to add top panel
frame .top_panel  -relief sunken -bd 2

#other buttons, below real space display
frame .realf.con
#frame .realf.con.topf
#frame .realf.con.bottomf
LASSPpresets .presets presetsave
LASSPpresets_configure .presets -font $font

frame .test1
button .qui -font $font -text "quit" -command "exit 0" -width 10
#button .realf.con.config -text "configure..." -command {tk_dialog .noconfig Sorry "bravais has no items to be configured." {} 0 Ok} -width 10
button .config -font $font -text "configure..." -command {tk_messageBox -type ok -icon error -message "bravais has no items to be configured." -parent . -title Sorry -default ok } -width 10
#button .realf.con.config -text "configure..." -command {bravais_sorry} -width 10
button .help -font $font -text "help..." -command {LASSPhelp2 .t2  [file join $SSS_DIR lib/bravais/bravais.htm]} -width 10

# the size selection.
LASSPselection .disp_type "display: " disp_option {set_para} \
	 "large" "medium" "small"
LASSPselection_configure .disp_type -font $font



###################pack all windows
pack .qui .disp_type .config .presets .help -in .top_panel -side left -fill x -padx 10
pack .top_panel -side top


pack .control1.latt_consts.phi  -side left -fill x -padx 10
pack .control1.latt_consts.a  -side left -fill x -padx 10
pack .control1.latt_consts.b -side left -fill x -padx 10
pack .control1.latt_consts  -side top -pady 1 -fill x
pack .control1

pack .recipf.posf.topf.length_l  -side left
pack .recipf.posf.topf.length_e  -side left
pack .recipf.posf.topf.angle_l  -side left
pack .recipf.posf.topf.angle_e  -side left
pack .recipf.posf.bottomf.diffraction -side left
pack .recipf.posf.bottomf.lattice -side left
pack .recipf.posf.topf -side top
pack .recipf.posf.bottomf -side bottom
pack .recipf.posf -side top -fill x

pack .recipf.vecf.planes -side left -padx 5
pack .recipf.vecf.hlab -side left
pack .recipf.vecf.h -side left
pack .recipf.vecf.klab -side left
pack .recipf.vecf.k -side left
pack .recipf.can  -side top
pack .recipf.vecf  -side top
pack .recipf -side right -expand yes



pack .control.atomAf  -side top -fill x -expand 1
pack .control.atomAf.toggle -fill x
pack .control.atomAf.a1 -fill x
pack .control.atomAf.b1 -fill x
pack .control.atomAf.z1 -fill x
pack .control.atomAf.r1 -fill x

pack .control.atomBf  -side top -fill x -expand 1
pack .control.atomBf.toggle -fill x
pack .control.atomBf.a2 -fill x
pack .control.atomBf.b2 -fill x
pack .control.atomBf.z2 -fill x
pack .control.atomBf.r2 -fill x
pack .control -side right -padx 5 -fill y


#pack .realf.con.topf.presets -side left
#pack .realf.con.topf.config -side right
#pack .realf.con.bottomf.help  -side left
#pack .realf.con.bottomf.qui   -side right
#pack .realf.con.topf -side top
#pack .realf.con.bottomf -side bottom
#pack .realf.con -side bottom -pady 3

pack .realf.posf.length_l -side left
pack .realf.posf.length_e -side left
pack .realf.posf.angle_l  -side left
pack .realf.posf.angle_e  -side left
pack .realf.posf.lattice  -side right
pack .realf.posf  -side top -fill x
pack .realf.can  -side top


pack .realf -side left -expand yes

bind . <Key-Escape> {.qui invoke}
#mod mjb 8/27/97
	 global brav_palette
	 if { $brav_palette == 0 } {
		tk_setPalette #d9d9d9
		set brav_palette 1
	 }
########################################################
# The configure all procedure
proc config_all {} {

global font wdth hght planes

#canvas
.realf.can configure -height $hght -width $wdth

#labels
.realf.posf.length_l configure -font $font
.realf.posf.angle_l configure -font $font
.realf.posf.length_e configure -font $font
.realf.posf.angle_e configure -font $font

#checkbutton
.realf.posf.lattice configure -font $font

#canvas
.recipf.can configure -height $hght -width $wdth

#label
.recipf.vecf.planes configure -font $font
.recipf.vecf.hlab configure -font $font
.recipf.vecf.klab configure -font $font

#label
.recipf.posf.topf.length_l configure -font $font
.recipf.posf.topf.angle_l configure -font $font
.recipf.posf.topf.length_e configure -font $font
.recipf.posf.topf.angle_e configure -font $font

#checkbutton
.recipf.posf.bottomf.lattice configure -font $font
.recipf.posf.bottomf.diffraction configure -font $font

#scales
LASSPscale2_configure .control1.latt_consts.phi -font $font
LASSPscale2_configure .control1.latt_consts.a -font $font
LASSPscale2_configure .control1.latt_consts.b -font $font

#checkbutton
.control1.latt_consts.lattice configure -font $font

#scales
LASSPscale2_configure .control.atomAf.a1 -font $font
LASSPscale2_configure .control.atomAf.b1 -font $font
LASSPscale2_configure .control.atomAf.z1 -font $font
LASSPscale2_configure .control.atomAf.r1 -font $font

#checkbutton
.control.atomAf.toggle configure -font $font

#scales
LASSPscale2_configure .control.atomBf.a2 -font $font
LASSPscale2_configure .control.atomBf.b2 -font $font
LASSPscale2_configure .control.atomBf.z2 -font $font
LASSPscale2_configure .control.atomBf.r2 -font $font

#checkbutton
.control.atomBf.toggle configure -font $font

#buttons
.qui configure -font $font
.config configure -font $font
.help configure -font $font

#selection
LASSPselection_configure .disp_type -font $font

#miller indices
.recipf.vecf.h configure -font $font
.recipf.vecf.k configure -font $font

# the presets
LASSPpresets_configure .presets -font $font

# procedure to redraw the elements.
pos_update
if {$planes != 0} { lattice_planes}
resize_atom

      global tcl_platform
      if { $tcl_platform(platform) != "windows" } { 
	  wm withdraw .
        set oldx [winfo x .]
        set oldy [winfo y .]
        wm deiconify .
        if { $tcl_platform(platform) == "macintosh"} {
        	if { $oldy <=20 } { set oldy 20}
        }
        wm geometry . +$oldx+$oldy
      }
	wm geometry . {}

}

# Setting the size option as per the correct value.
LASSPselection_set .disp_type $disp_option


