

proc LASSPhelp_save {w file} {
    if {[file exists $file]} {
	if {[tk_dialog .temp {} "File $file already exists.  Overwrite it?" \
		{} 1 Ok Cancel]} return
    }
    set fnum [open "$file" w]
    puts $fnum [$w.text get 0.0 end]
    close $fnum
}


################################## create a popup help window ############
proc LASSPhelp {w file} {
    if {[winfo exists $w]} {
	raise $w
    } else {
	toplevel $w 
	wm title $w "Help"
	wm minsize $w 100 100
	text $w.text -yscrollcommand "$w.scroll set" -width 80 -wrap word
	scrollbar $w.scroll -relief flat -command "$w.text yview"
	frame $w.f
	button $w.exit -relief raised -text "close" -width 10 \
		-command "destroy $w"
	pack $w.f  -side top -fill x
	pack $w.exit -in $w.f -side left
	pack $w.scroll -side right -fill y
	pack $w.text -side left -expand yes -fill both
	set fnum [open "$file" r]
	$w.text insert current [read $fnum]
	close $fnum
	if {![file writable $file]} {
	    $w.text config -state disabled
	} else {
	    button $w.save -relief raised -text "save" -width 10 \
		    -command "LASSPhelp_save $w $file"
	    pack $w.save -in $w.f -side left
	}
    }

}
