#!/usr/local/bin/wish -f

proc getcmd {} {
    gets stdin cmd
    while {![info complete $cmd]} {
	gets stdin str
	set cmd [format {%s %s} $cmd $str]
    }
    return $cmd
}

puts -nonewline "% "
set cmd [getcmd]
while {0!= [string compare $cmd "exit"]} {
    catch $cmd result
    if {[string length $result]!=0} {
	puts stdout "$result"
    }  
    puts -nonewline "% "
    set cmd [getcmd]
}

exit

